COMMENT * Original code by dedndave on MASM32 Forum.  Modifications,
additions, tpyos, and corrections FORTRANS (Steve) on MASM32 Forum.
27 November 2009

REM Create BooSect.BIN, NOT sure about ML switches.
\MASM32\BIN\ML /AT /c /Fl /Fm BootSect.ASM
\MASM32\BIN\LINK16 BootSect.OBJ;
EXE2BIN BootSect.EXE

11/27/2009  04:02p                  40 BOOTLOAD.BIN
11/27/2009  04:02p                 512 BOOTSECT.BIN

DEBUG BootSect.BIN
-w 100 0 0 1
-q

DEBUG BootLoad.BIN
-w 100 0 1 1
-q

TODO:  Use a different sector to write/read BootLoad.BIN to.
       Convert to hexadecimal and display contents of CS and IP.
*

        .MODEL  TINY
        .CODE

;----------------------------------------------------------------------

LoadOfs EQU     0
LoadSeg EQU     1000h

;----------------------------------------------------------------------

;---------------------- branch to executable code

        ORG     0

Boot0:  jmp short Boot1
        NOP     ; - - - Mods to deadndave's code: Win2K error fix,
                ; - - - original was a zero.

;---------------------- OEM identifier

        ORG     3

        DB      "Zulfi OS"

;---------------------- BIOS parameter block for 1.44 Mb floppy disk
; - - - Mod to 720K - - -

        ORG     0Bh

bpbBytesPerSector    DW 512
bpbSectorsPerCluster DB 2 ; 1   Mods to deadndave's code: Cluster size,
                             ; may/may not have caused a problem?
bpbReservedSectors   DW 1
bpbNumberOfFATs      DB 2
bpbRootEntries       DW 112  ; 224    Mods to deadndave's code: 720 K
bpbTotalSectors      DW 1440 ; 2880   diskette instead of 1.44 M
bpbMedia             DB 0F9H ; 0F0h
bpbSectorsPerFAT     DW 3    ; 9
bpbSectorsPerTrack   DW 9    ; 18
bpbHeadsPerCylinder  DW 2
bpbHiddenSectors     DD 0
bpbTotalSectorsBig   DD 0
bsDriveNumber        DB 0
bsUnused             DB 0
bsExtBootSignature   DB 29h
bsSerialNumber       DD 0a0a1a2a3h
bsVolumeLabel        DB "MOS FLOPPY "
bsFileSystem         DB "FAT12   "

;---------------------- initialize SS:SP

Boot1:  cli                     ;disable maskable interrupts
        xor     di,di
        mov     ss,di
        mov     sp,7C00h        ;SS:SP = 0000:7C00
        sti                     ;enable maskable interrupts

;---------------------- display 'A' character

        cld
        mov     ax,0B800h       ; CGA text memory segment
        mov     es,ax
        mov     ax,1F41h
        stosw                   ; Store character and attribute.

;---------------------- wait for a keypress

        mov     ah,0            ; Keboard BIOS wait for character.
        int     16h

;---------------------- read the bootloader code

        mov     cx,5            ;retry count

Reset0: push    cx
        mov     ah,0            ;reset floppy disk function
        mov     dl,0            ;drive A:
        int     13h

        mov     ax,LoadSeg      ;read sector into address LoadSeg:LoadOfs
        mov     es,ax
        mov     bx,LoadOfs

        mov     cx,2            ;cylinder 0, sector 2 (1 based)
        xor     dx,dx           ;head 0, drive 0
        mov     ax,201h         ;read 1 sector
        int     13h
        pop     cx
        jnc     Exec0

        loop    Reset0

;---------------------- failed 5 times - halt
; - - - display 'F' character - - -
; - - - to show the failure occured.

        mov     ax,0B800h
        mov     es,ax
        mov     DI,4    ; Move a bit to avoid the 'A',
        mov     ax,9C46h; 9C attribute should be ugly.
        stosw

Halt0:  HLT
        jmp     Halt0

;---------------------- execute the bootloader code

Exec0:
        db      0EAh            ;JMP FAR instruction
        dw      LoadOfs         ;offset
        dw      LoadSeg         ;segment


;---------------------- boot sector signature

        ORG     1FEh

        dw      0AA55h

;----------------------------------------------------------------------------------

        END     Boot0
